	TITLE	zadanie5.asm
;=======================================================================
;
; Definovanie symbolickych konstant
;
;=======================================================================
LF	EQU	10	;Line Feed
CR	EQU	13	;Carriage Return
;
;

	DOSSEG
	.MODEL	SMALL
	.STACK	200h		;512-byte stack
	.DATA
;=======================================================================
;
; Definovvanie datovych struktur,typov a konstant
;
;=======================================================================
Vysledok	DB	'Pocet sestnastkovych cislic v subore je: ',6 DUP(?),13,10,'$'
Znak		DB	0 			;Nacitany znak
CisloSuboru	DW	?			;Cislo otv. suboru (kanalu, handle)
MenoSuboru	DB	'zadanie5.txt',0	;Meno suboru
Vyzva	LABEL	BYTE
 DB	13,10
 DB	13,10
 DB	13,10
 DB	13,10
 DB	'    ZADANIE CISLO 5:',13,10
 DB	'    ~~~~~~~~~~~~~~~~',13,10
 DB	13,10
 DB	'    Nacitajte zo suboru retazec znakov ukonceny znakom "noveho riadku".  ',13,10
 DB	'    Nech slovo je postupnost znakov medzi dvoma znakmi "medzera". Urcte  ',13,10
 DB	'    pocet slov reprezentujucich zapis sestnastkoveho cisla podla syntaxe ',13,10
 DB	'    jazyka C. Pocet vytlacte sestnastkovo                                ',13,10
 DB	'$'
;
FeedLines	LABEL BYTE
	DB	13,10
	DB	13,10
	DB	'$'
;
;
	.CODE
;=======================================================================
;
; Start:
; ~~~~~~
; Telo programu
;
;
;=======================================================================
Start:	mov	ax,@data
	mov	ds,ax		;Inicializacia datoveho segmentu
	mov	dx,offset Vyzva
	call	OutString
	mov	di,0h
; Otvorenie suboru pomocou prerusenia 21h cislo 3dh. Otvara podla mena suboru 
; vretazci ASCIIZ, ktoreho adresa je ulozena v DS:DX a v registri AX 
; sa odovzdavaju parametre otvorenia.
	mov	dx,offset FeedLines
	call	OutString
	mov	ah,3dh			;Funkcia cislo 3dh
	mov	al,0h			;Parametre otvorenia
	mov	dx,offset MenoSuboru	;Adresa mena suboru
	int	21h			;Volanie prerusenia
	jnc	Analyza			;Nastala chyba?
	jmp	Chyba
;
; Nasleduje analyza prveho riadku suboru. Ak subor neobsahuje ziaden znak
; noveho riadku, bude sa analyzovat cely. Analyza spociva vo vyhladani
; retazcov, ktore splnaju podmienky syntaxu pre hexadecimalne cilsa 
; jazyka C. Cize hladame retazce, ktore povinnem zacinaju znakom '0',
; za ktorym nasleduje znak 'x' alebo 'X'. Ostatne znaky musia byt z mnoziny
; {0,1,2,3,4,5,6,7,8,9,A,B,C,D,E,F,a,b,c,d,e,f}.
Analyza:
	mov	[CisloSuboru],ax
	mov	ax,0h			;AX - pocitadlo cisiel
Analyza_1:
	call	CitajZnak
	cmp	[Znak],'0'		;Prvy znak je 0 ?
	jnz	Analyza_9
	call	CitajZnak
	cmp	[Znak],'X'		;Druhy znak X
	jz	Analyza_2
	cmp	[Znak],'x'
	jnz	Analyza_9		;alebo drhy znak x
Analyza_2:
; Tato cast kontroluje ci znaky v retazci su z intervalu <'0';'7'>
	call	CitajZnak
	cmp	[Znak],CR		;Koniec riadku?
	jz	VypisVysledku
	cmp	[Znak],' '		;Koniec retazca?
	jz	Analyza_1
Analyza_3:
; Tu sa zistuje ci znak je z intervalu <0;9>
	cmp	[Znak],'9'
	ja	Analyza_5		;Ak [Znak] > '9' skoci
	cmp	[Znak],'0'	
	jb	Analyza_10		;Ak [Znak] < '0' skoci
Analyza_8:
	call	CitajZnak
	cmp	[Znak],CR		;Koniec riadku?
	jnz	Analyza_4
	inc	ax			;Zapocitame posledne hex. cislo
	jmp	VypisVysledku
Analyza_4:
	cmp	[Znak],' '		;Koniec retazca?
	jnz	Analyza_3
	inc	ax			;Zapocitame dalsie hex. cislo
	cmp	ax,0ffffh
	jnz	Analyza_1		;Ideme na dalsi retazec
	jmp	VypisVysledku		;Pocitadlo naplnene
Analyza_5:
; Tu sa zistuje ci znak je z intervalu <A;F>
	cmp	[Znak],'F'
	ja	Analyza_7
	cmp	[Znak],'A'
	jb	Analyza_10
	jmp	Analyza_8
Analyza_7:
; Tu sa zistuje ci znak je z intervalu <a;f>
	cmp	[Znak],'f'
	ja	Analyza_10
	cmp	[Znak],'a'
	jb	Analyza_10
	jmp	Analyza_8
Analyza_9:
; Tato cast je vlastne posun na dalsi retazec v riadku
	cmp	[Znak],CR		;Koniec riadku?
	jz	VypisVysledku		;Ak ano vypis vysledku
	cmp	[Znak],' '		;Koniec retazca?
	jnz	Analyza_10		;Ak ano prejdi na dalsi retazec
	jmp	Analyza_1
Analyza_10:
	call	CitajZnak
	jmp	Analyza_9
;
; Po analyze udajov v riadku, mame pocet najdenych setnastkovych cisiel
; v registri AX. Obsah registra AX prevedieme na osmickove cislo,
; reprezentovane ASCII retazcom a tento retazec vypiseme na obrazovku

VypisVysledku:
	mov	di,46d		;Index na miesto najnizsej cislice
	mov	dx,ax		;Kopia vysledku
	mov	cx,0h
	mov	bl,6h		;Pocitadlo prevodu
Prevod:
	shr	ax,cl			;Posun doprava
	and	ax,0007h		;Maska
	add	al,'0'			;Prevod na ASCII znak
	mov	[Vysledok+di],al	;Ulozenie znaku
	dec	bl
	jz	Uprava
	dec	di			;Presun na dalsi znak
	mov	ax,dx
	add	cl,3h
	jmp	Prevod

; Po prevedeni vysledku moze vysledok obsahovat nepodstatne nuly. To su
; take, ktore stoja pred cislom (teda nemaju vplyv na jeho hodnotu.
; Zmazane budu vsetky okrem jednej pre zachovanie syntaxe pre osmickove
; cisla z jazyka C.

Uprava:	mov	bl,5h
	inc	di
Uprava_1:
	cmp	[Vysledok+di],'0'
	jnz	VypisVysledku_1
	mov	[Vysledok+di-1h],' '
	inc	di
	dec	bl
	jnz	Uprava_1

; Uprava bola ukoncena. Nasleduje vypis vysledku.
VypisVysledku_1:
	mov	ah,9h			;Funkcia cislo 9h
	mov	dx,offset Vysledok
	int	21h
; Podla cisla suboru umiestneho v registri BX, zatvori subor otvoreny
; funkciou 3dh alebo 3ch alebo vznikol duplikaciou ineho kanala.
ZatvorSubor:
	mov	ah,3eh			;Funkcia cislo 3eh
	mov	bx,[CisloSuboru]		;Predanie cisla suboru
	int	21h
Chyba:	call	Koniec
;
;
;
;=======================================================================
;
; CitajZnak:
; ~~~~~~~~~~
; Nacita z otvoreneho suboru jeden znak.
;
; Vstupne parametre:
;	CisloSuboru - pametove miesto s cislom (handle) suboru
;	Znak	    - adresa kam sa ulozi nacitany znak
;
; Vystupne paranetre:
;	Carry Flag  - CF=1 pri chybe, CF=0 ak vsetko ok
;	register AX - pocet nacitanych znakov, alebo kod chyby ak CF=1
;
;
;=======================================================================
CitajZnak	PROC	NEAR
	push	ax
	push	bx
	push	cx
	push	dx
	mov	bx,[CisloSuboru]	;Cislo suboru
	mov	cx,1h			;Pocet byte-ov
	mov	dx,offset Znak
	mov	ah,3fh			;Funkcia cislo 3fh
	int	21h
	jnc	CitajZnak_1		;Ak nastala chyba pri citani koniec
	call	Koniec
CitajZnak_1:
	cmp	ax,0h			
	jnz	CitajZnak_2
	mov	[Znak],CR		;Nenacital nic a CF=0 => EOF
CitajZnak_2:
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	ret
CitajZnak	ENDP
;
;
;=======================================================================
;
; OutString:
; ~~~~~~~~~~
; Vypise na monitor retazec so zaciatkom na offsetovej adrese zadanej
; v registri DX az po najblizsi znak '$'.
;
; Vstupne parametre:
;	register DX - offset retazca
;
; Vystupne parametre:
;	ZIADNE
; 
;=======================================================================
OutString	PROC	NEAR
	push	ax
	mov	ah,9h
	int	21h
	pop	ax
	ret
OutString	ENDP
;
;
;=======================================================================
;
; Koniec:
; ~~~~~~~
; Ukoncenie behu programu.
;
;=======================================================================
Koniec	PROC	NEAR
	mov	ax,4c00h		;Funkcia 4ch
	int	21h
Koniec	ENDP
;
;
END	Start